Ubuntu

Mesa related GPU hangs on Sandybridge and Ivybridge systems

Reported by Robert Hooker on 2012-03-27
18
This bug affects 2 people
Affects Status Importance Assigned to Milestone
mesa (Ubuntu)
Undecided
Unassigned
Oneiric
High
Robert Hooker
Precise
Undecided
Unassigned

Bug Description

During QA testing of 11.10 on unreleased Ivybridge systems, we have encountered quite a few GPU hang bugs in mesa that take out the desktop that have been fixed in the stable mesa-7.11 branch after 11.10 released. Given that 7.11.2 is quite large and different than 7.11.0 that is in oneiric, I've backported just the fixes for the issues we have found and they are all included in 12.04.

These include:

GPU reset loop leading to a hard hang of the system when these apps are run on Ivybridge: qgears2, openarena, unigine heaven, trine, minecraft
Hard hang of the system when these apps are run on Sandybridge: trine, oilrush
Wrong colors rendered in lightsmark on Ivybridge

[Development Fix]
Upstream commits fixing these issues that are included in the patch stack and are also in 12.04's mesa:
http://cgit.freedesktop.org/mesa/mesa/commit/?h=7.11&id=439628318bfd4596d0d8129a0792d2c3ea849bb7

http://cgit.freedesktop.org/mesa/mesa/commit/?h=7.11&id=38dfedccb2a2b695a600350a75113e8c35683498

http://cgit.freedesktop.org/mesa/mesa/commit/?id=c25e5300cba7628b58df93ead14ebc3cc32f338c

http://cgit.freedesktop.org/mesa/mesa/commit/?id=172bb92db1a3c317867d9cfec6f15c09c37a0f6c

[Stable Fix]
Manually backporting those 4 commits

[Test Case]
1. log in to desktop on an Ivybridge system
2. install phoronix-test-suite (sudo apt-get install phoronix-test-suite)
3. run lightsmark or qgears2 test (phoronix-test suite run lightsmark)

If it fails, dmesg will be flooded with these errors and the desktop will be unusable

Jan 26 12:44:41 u kernel: [ 4260.408090] [drm:i915_hangcheck_elapsed] *ERROR* Hangcheck timer elapsed... GPU hung
Jan 26 12:44:41 u kernel: [ 4260.408104] [drm] capturing error event; look for more information in /debug/dri/0/i915_error_state
Jan 26 12:44:41 u kernel: [ 4260.414015] [drm:i915_wait_request] *ERROR* i915_wait_request returns -11 (awaiting 1332092 at 1332083, next 1332093)
Jan 26 12:44:47 u kernel: [ 4266.772122] [drm:i915_hangcheck_elapsed] *ERROR* Hangcheck timer elapsed... GPU hung
Jan 26 12:48:11 u kernel: [ 4470.536612] qgears[27719]: segfault at 0 ip 01d36611 sp bfd950c0 error 4 in i965_dri.so[1cc2000+bc000]

GPU: 00:02.0 VGA compatible controller: Intel Corporation Ivy Bridge Graphics Controller (rev 08)

Robert Hooker (sarvatt) wrote :

Debdiff containing the fixes

description: updated
tags: added: oneiric patch
description: updated
Robert Hooker (sarvatt) on 2012-03-27
Changed in mesa (Ubuntu Precise):
status: New → Fix Released
Changed in mesa (Ubuntu Oneiric):
status: New → In Progress
importance: Undecided → High
assignee: nobody → Robert Hooker (sarvatt)
milestone: none → oneiric-updates
description: updated
Robert Hooker (sarvatt) on 2012-03-27
description: updated
Robert Hooker (sarvatt) on 2012-03-28
tags: added: blocks-hwcert-enablement
Timo Aaltonen (tjaalton) wrote :

yep, looks good and fixed the issues on my test system, uploaded to oneiric-proposed.

Hello Robert, or anyone else affected,

Accepted mesa into oneiric-proposed. The package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in mesa (Ubuntu Oneiric):
status: In Progress → Fix Committed
tags: added: verification-needed
James Ferguson (jamesf) wrote :

I can confirm this fixes the issue on a number of Ivy Bridge systems we have tested, with no regressions observed.

Robert Hooker (sarvatt) wrote :

Verified here as well with mesa in proposed

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package mesa - 7.11-0ubuntu3.2

---------------
mesa (7.11-0ubuntu3.2) oneiric-proposed; urgency=low

  * Add patch series from upstream stable release to fix various issues:
    - 121-i965-fix-border-color.patch: Fixes wrong colors in lightsmark
      (LP: #966399)
    - 122-i965-apply-post-sync-workaround.patch: Fixes GPU hangs in
      Civilization 4, PlaneShift, Minecraft, Neverwinter Nights
      (among others) on Sandybridge and Ivybridge. (LP: #966399)
    - 123-i965-emit-depth-stalls-and-flushes.patch: Fixes GPU hangs when
      running qgears2, lightsmark, and openarena on Ivybridge. (LP: #966399)
    - 124-i965-last-render-target-select.patch: Fixes a GPU hang when
      running Trine, or Unigine Heaven which crashes the desktop. (LP: #966399)
  * Drop 120_fix_tfp_texture_free.patch from previous SRU, it was the
    incorrect patch.
 -- Robert Hooker <email address hidden> Tue, 20 Mar 2012 10:44:16 -0400

Changed in mesa (Ubuntu Oneiric):
status: Fix Committed → Fix Released
ramayer (rm-ubuntu) wrote :

Using 12.04 LTS 64-bit, on an Ivy Bridge Core i5 3570K I'm getting frequent (about every 1-2 days) hard hangs of the system.

Mouse is NOT responsive - can not move or click the mouse.

Keyboard is NOT responsive.
Can not Ctrl-F1.
Can not Magic SysRq.

Is this fix in the 64-bit 12.04 LTS release?

ramayer (rm-ubuntu) wrote :

I think this bug was closed incorrectly.

Actual fix for this is here -- in the 3.3.6 kernel:

http://kernel.ubuntu.com/~kernel-ppa/mainline/v3.3.6-precise/

And Ubuntu packages for 3.2.x here:

http://people.canonical.com/~ogasawara/eugeni/rc6/

For more info:

http://lists.freedesktop.org/archives/intel-gfx/2012-February/015029.html

ramayer (rm-ubuntu) wrote :

Oh - and quite a bit more discussion of the bug here: https://bugs.launchpad.net/ubuntu/+source/xorg/+bug/993187

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers